#lang racket

;;;; 1. cvičenie z predmetu 2-AIN-285 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.10.1
;;;; Dátum: 21.2.2018
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/2-AIN-285-lisp/1718ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - vyhodnocovanie výrazov,
;;;; - explicitné definície,
;;;; - rekurzívne definície.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 1 
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 0
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0 
;;;; Odovzdať do 27.2.2018 (utorok) do 14:00.

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;;; Kapitola. Explicitné definície.

;;; Sekcia. Jednoduché explicitné definície.

;; Príklad. Nasledujúci komponent obsahuje definíciu funkcie, ktorá vráti
;; štvorec (druhú mocninu) daného čísla.

(define (square x) (* x x))

;; (square 5)
;; (query square 0 10)

;; Úloha. Definujte funkciu, ktorá pre dané číslo vráti jeho tretiu mocninu.

(define (cube x) ...)

;; (cube 5)
;; (query cube 0 10)

;; Úloha. Zostrojte program, ktorý pre dané dve čísla vypočíta súčet ich
;; štvorcov. 

(define (sum-of-squares x y) ...)

;; (sum-of-squares 3 4)
;; (query (λ (y) (sum-of-squares 1 y)) 0 10)

;;; Sekcia. Priradenia.

;; Príklad. Nasledujúci komponent obsahuje program pre funkciu, ktorá pre dané
;; číslo vráti jeho štvrtú mocninu. Všimnite si použitie špeciálnej formy let.
;; Tá zaručí, že sú potrebné len 2 násobenia.

(define (fourth-power x) (let ([y (* x x)]) (* y y)))

;; (fourth-power 5)
;; (query fourth-power 0 10)

;; Úloha. Zostrojte program, ktorý vypočíta piatu mocninu vstupného čísla.
;; Nájdite implementáciu, v ktorej sú potrebné len 3 násobenia.

(define (fifth-power x) ...)

;; (fifth-power 5)
;; (query fifth-power 0 10)

;;; Sekcia. Podmienkové výrazy.

;; Príklad. Nasledujúci komponent obsahuje definíciu signum funkcie, ktorá
;; vráti znamienko daného reálneho čísla:
;;   (x > 0 → sgn(x) = 1) ∧ sgn(0) = 0 ∧ (x < 0 → sgn(x) = -1)
;; Všimnite si použitie špeciálnej formy cond.

(define (sgn x)
  (cond [(> x 0) 1]
        [(= x 0) 0]
        [(< x 0) -1]))

;; Alternatívna definícia pomocou špeciálnej formy else.

(define (sgn2 x)
  (cond [(> x 0) 1]
        [(= x 0) 0]
        [else -1]))

;; Alternatívna definícia pomocou špeciálnej formy if.

(define (sgn3 x)
  (if (> x 0)
      1
      (if (= x 0)
          0
          -1)))

;; Úloha. Definujte funkciu abs, ktorej výsledkom pre dané reálne číslo je jeho
;; absolútna hodnota:
;;   (x > 0 → abs(x) = x) ∧ abs(0) = 0 ∧ (x < 0 → abs(x) = -x)

(define (abs x) ...)

;; Úloha. Definujte binárnu funkciu min, ktorá pre dané dve čísla vráti ich
;; minimum:
;;   min(x,y) ≤ x ∧ min(x,y) ≤ y ∧ (min(x,y) = x ∨ min(x,y) = y)

(define (min x y) ...)

;; Úloha. Definujte binárnu funkciu max, ktorej výsledkom pre dané dve čísla je
;; ich maximum:
;;   max(x,y) ≥ x ∧ max(x,y) ≥ y ∧ (max(x,y) = x ∨ max(x,y) = y)

(define (max x y) ...)

;; (1 bod)
;; Úloha. Definujte ternárnu funkciu median, ktorá pre dané tri čísla vráti ich
;; medián:
;;   x ≤ y ∧ y ≤ z → median(x,y,z) = y
;;   median(x,y,z) = median(y,x,z) ∧ median(x,y,z) = median(x,z,y)

(define (median x y z) ...)

;;; Sekcia. Explicitné definície predikátov.

;; Príklad. Nasledujúci komponent obsahuje definíciu predikátu even?, ktorý
;; testuje, či vstupné číslo je párne:
;;   even?(x) ↔ ∃n x = 2n

(define (even? x) (= (remainder x 2) 0))

;; (and (even? 2) (not (even? 3)))
;; (query even? 0 10)

;; Alternatívna definícia s využitím boolovských konštánt.

(define (even2? x) (if (= (remainder x 2) 0) #t #f))

;; (and (even2? 2) (not (even2? 3)))
;; (query even2? 0 10)

;; Úloha. Definujte predikát odd?, ktorý testuje, či vstupné číslo je nepárne:
;;   odd?(x) ↔ ∃n x = 2n+1

(define (odd? x) ...)

;; (and (not (odd? 2)) (odd? 3))
;; (query odd? 0 10)

;; Alternatívna definícia s využitím boolovských konštánt.

(define (odd2? x) ...)

;; (and (not (odd2? 2)) (odd2? 3))
;; (query odd2? 0 10)
